Last Comment Bug 704589 - Support updating of natively-installed apps
: Support updating of natively-installed apps
Status: VERIFIED FIXED
[qa!]
:
Product: Firefox Graveyard
Classification: Graveyard
Component: Webapp Runtime (show other bugs)
: unspecified
: x86 Windows 7
: P2 normal
: ---
Assigned To: Nobody; OK to take it and work on it
: Jason Smith [:jsmith]
:
Mentors:
Depends on: 725408
Blocks:
  Show dependency treegraph
 
Reported: 2011-11-22 12:34 PST by Tim Abraldes [:TimAbraldes] [:tabraldes]
Modified: 2016-03-21 12:39 PDT (History)
9 users (show)
jsmith: in‑moztrap+
See Also:
QA Whiteboard:
Iteration: ---
Points: ---


Attachments

Description Tim Abraldes [:TimAbraldes] [:tabraldes] 2011-11-22 12:34:30 PST
Currently the only way to update a natively-installed app is to uninstall/reinstall.

Reasons to provide an update mechanism:
   Bug fixes in the native-app implementation
   New Firefox version is available on user's machine (at a minimum this requires modifying the application.ini file in the natively-installed app)
   Extending the feature set of natively-installed apps
Comment 1 Dan Walkowski 2011-12-02 10:24:40 PST
We do need native app updating for handling the case that the snippet of code in the native launch binary needs updating.

A new Firefox version will get used automatically after installation (at least on Mac, what about Windows?), no .ini file changes.

Extending the feature set might require a native-app update, but I think could instead be put into the addon.  Apps are going to have to query for what extended apis are available anyway, so they can look in the addon, in some standard place, and the code could be injected from there.  I think. :)
Comment 2 Tim Abraldes [:TimAbraldes] [:tabraldes] 2011-12-02 10:44:31 PST
(In reply to Dan Walkowski from comment #1)
> We do need native app updating for handling the case that the snippet of
> code in the native launch binary needs updating.

Yup!

> A new Firefox version will get used automatically after installation (at
> least on Mac, what about Windows?), no .ini file changes.

I was thinking about the case where the new version of Firefox exceeds the maxVersion in the XUL app's application.ini.  It would be a bummer to update Firefox and suddenly find that launching apps just throws an error dialog

> Extending the feature set might require a native-app update, but I think
> could instead be put into the addon.  Apps are going to have to query for
> what extended apis are available anyway, so they can look in the addon, in
> some standard place, and the code could be injected from there.  I think. :)

That sounds pretty awesome, but what about menus and such that are specified in XUL?
Comment 3 Jason Smith [:jsmith] 2012-02-11 16:14:20 PST
A Pivotal Tracker story has been created for this Bug: http://www.pivotaltracker.com/story/show/24808703
Comment 4 Jason Smith [:jsmith] 2012-03-20 12:12:47 PDT
Jen - This is not needed to be built around the same time marketplace beta is released, right? Can you confirm?
Comment 5 Dan Walkowski 2012-03-20 13:13:29 PDT
Updating of the native app runtime is automatic, and already implemented for both Mac and Windows.
Comment 6 Jason Smith [:jsmith] 2012-05-04 14:42:41 PDT
Dan - Could you clarify what I need to do to verify this bug? Trying to figure out what I need to test here.
Comment 7 Dan Walkowski 2012-05-07 14:04:11 PDT
Well, the easiest way would be to fake a newer version of the webapprt in Firefox, then launch an app, and the new version will get copied in.  You could make the one in the app 'older', but that requires more work, as the version # is compiled in.
Comment 8 Jason Smith [:jsmith] 2012-05-12 08:50:03 PDT
(In reply to Dan Walkowski from comment #7)
> Well, the easiest way would be to fake a newer version of the webapprt in
> Firefox, then launch an app, and the new version will get copied in.  You
> could make the one in the app 'older', but that requires more work, as the
> version # is compiled in.

Hmm okay. Since the web apps implementation has nightly build support with some FF 14 builds and FF 15 builds, could it be possible to verify the bug this way:

1. Install a Firefox 14 Nightly build on 4/23/2012
2. Install some web applications
3. Launch those web applications
4. Update the nightly build to the latest Firefox 15 Nightly build
5. Re-launch those applications
Comment 9 Jason Smith [:jsmith] 2012-05-16 23:34:58 PDT
Verified on OS X 10.7 and Windows 7 64-bit.

Note You need to log in before you can comment on or make changes to this bug.